#!/usr/bin/perl
############################################################################
# NCSA style log file generator by Ian Johnston - ianj@trials.co.uk
# Slightly modified by LMG
# Put this on every page - <IMG SRC="http://www.yourdomain/cgi-bin/log.cgi">

$logfile = '/home/username/public_html/log/logfile.log'; # Name of logfile and location
$piccy = "piccy.gif";       # file to print to screen (tiny transparent gif).

# create a date & time string
require "/usr/local/lib/perl5/ctime.pl";       # time/date stamp (Sparcstation)
$shortdate=&ctime(time);
chop($shortdate);                              # But, currently prints - 'Tue Jan 20 14:14:34 GB 1998' or 'Wed Jan 21  5:14:34 GB 1998'
$shortdate =~ tr/"\x20""\x20"/"\x20"/s;        # If there is a double space (single figure hours) then replace it with a single space
$shortdate =~ tr/"\x20"/"\x2f"/;               # Replace all spaces with front slash. I.e. 'Tue/Jan/20/14:14:34/GB/1998'
@fields = split (/\x2f/,$shortdate);           # split won't accept the front slash so using hex equivalent \x2f
                                               # now @fields = ("Tue","Jan","21","14:14:34","GB","1998") - so now reprint in correct order
$shortdate = @fields[2] . "\x2f" . @fields[1] . "\x2f" . @fields[5] . ":" .
@fields[3] . "\x20" . "+0000";  # Now prints 20/Jan/1998:14:14:34 +0000

# open log file for output and append new log data in NCSA format
open (LOGFILE, ">>$logfile");
print LOGFILE "$ENV{'REMOTE_HOST'} - - ";                  # domain
print LOGFILE "[$shortdate] ";                             # date and time
print LOGFILE "\"GET $ENV{'HTTP_REFERER'}";                # page referred from
print LOGFILE " HTTP/1.0\" ";                              # 
print LOGFILE "200 -";                                     # code/file size - THIS BIT TEMPORARY FOR NOW till find out how to get file size etc?
print LOGFILE "- \"$ENV{'HTTP_USER_AGENT'}\"";              # web browser and OS
print LOGFILE "\n";                                        # carriage return
close (LOGFILE);

### --- ADDON BY LMG 03.Feb.98

## Returning the image
open(IN,$piccy);

binmode IN; # To make sure DOS doesn't mess with EOL chars

# The image is now cached, as one gets a lot of spurious requests otherwise

print "Content-type: image/gif\n\n";

binmode STDOUT; # Ditto
while (<IN>) {
    print "$_";
}
close(IN);

exit;
